Index: main/asterisk.c
===================================================================
--- main/asterisk.c	(revision 166566)
+++ main/asterisk.c	(working copy)
@@ -81,7 +81,12 @@
 #elif defined(HAVE_SYSCTL)
 #include <sys/param.h>
 #include <sys/sysctl.h>
+#if !defined(__FreeBSD__)
 #include <sys/swap.h>
+#else 
+#include <sys/vmmeter.h>
+#include <vm/vm_param.h>
+#endif /* __FreeBSD__ */
 #endif
 #include <regex.h>
 
@@ -541,7 +546,7 @@
 #elif defined(HAVE_SYSCTL) && !defined(HAVE_SYSINFO)
 static int swapmode(int *used, int *total)
 {
-	used = total = 0;
+	*used = *total = 0;
 	return 1;
 }
 #endif
@@ -579,7 +584,11 @@
 	uptime = uptime/3600;
 	/* grab total physical memory  */
 	mib[0] = CTL_HW;
+#if defined(__FreeBSD__)
+	mib[1] = HW_PHYSMEM;
+#else
 	mib[1] = HW_PHYSMEM64;
+#endif
 	len = sizeof(physmem);
 	sysctl(mib, 2, &physmem, &len, NULL, 0);
 
@@ -603,8 +612,13 @@
 	swapmode(&usedswap, &totalswap); 
 	freeswap = (totalswap - usedswap);
 	/* grab number of processes */
+#if defined(__FreeBSD__)
+	mib[0] = CTL_HW;
+	mib[1] = HW_NCPU;
+#else
 	mib[0] = CTL_KERN;
 	mib[1] = KERN_NPROCS;
+#endif
 	len = sizeof(nprocs);
 	sysctl(mib, 2, &nprocs, &len, NULL, 0);
 #endif
